/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package imageviewer;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.text.Text;
import javafx.scene.text.Font;
import java.io.File;
import java.lang.String;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.Tile;
import javafx.scene.layout.HBox;

/**
 * @author mg
 */
class ImageViewer {
}

function run(args: String[]) {

    // do something with args[0]
    var stageWidth = 500;
    var stageHeight = 300;
    var filePath;
    var message = "";
    var imageName = "";
    var imagePath = "";
    var visibleImage = false;
    var title = "ImageViewer Manuel Graf";
    var titleDefault = "ImageViewer Manuel Graf";

    if (sizeof args > 0) {
        filePath = args[0];
        message = "directory: '{filePath}'"
    } else {
        filePath = "./";
        println(filePath);
        message = "no directory chosen, picking \n '{filePath}'";
    }

    var dir = new File(filePath);

    var imageFiles = [];

    if (dir.isDirectory()) {
        //list that stuff
        imageFiles = dir.list(new ImageFilter());
//        for (i in imageFiles) {
//            println(i)
//        }

    }

    var resizeImage = HBox {
                var img = bind imagePath;
                visible: bind visibleImage
                content: []
                onMouseClicked: function(e: MouseEvent): Void {
                    visibleImage = false;
                    title = titleDefault;
                }
                blocksMouse:true

            }

    Stage {
        title: bind title
        scene: Scene {
            width: stageWidth
            height: stageHeight

            content: [

                Tile {
                    columns: 5
                    content: {
                        if (sizeof imageFiles == 0) {
                            Text {
                                font: Font {
                                    size: 14
                                }
                                x: 10
                                y: 15
                                content: bind "{message}"
                            }
                        } else {
                            for (i in imageFiles) {
                                ImageView {
                                    image: Image {
                                        url: "file:{filePath}{i}"
                                        width: 100
                                        preserveRatio: true
                                    }
                                    onMouseClicked: function(e: MouseEvent): Void {

                                            visibleImage = true;

                                            title = "{i}";
                                            imagePath = "file:{filePath}{i}";
                                            resizeImage.content = ImageView {
                                                        image: Image {
                                                            url: "file:{filePath}{i}"
                                                            width: 300
                                                            height: 300
                                                            backgroundLoading: false
                                                            preserveRatio: true
                                                        }
                                                    }

                                    }
                                }
                            } }
                    }
                }, resizeImage]
        }
    }

}
